#
# SliMP3 Server
# Copyright (C) 2001 Sean Adams, Slim Devices Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.




# Currently the SliMP3 has just one mode - "browse". In the future there will be other 
# modes, such as "setup" or "create playlists". For each such mode, there will be a file like
# this, named buttons_XXXX, where XXX is the name of the "mode".
# 
# Each button on the remote has a function:

$buttons_browse{'menu'} = sub {
  $c->mode_random(0);
  &loaddir('');
};

$buttons_browse{'up'} = sub {
  $c->mode_random(0);
  $c->selectedisnext(1);
  if ($c->curdiritem==0) {
    $c->curdiritem($c->numdiritem-1);
  } else {
    $c->curdiritem($c->curdiritem-1);
  }
};

$buttons_browse{'down'} = sub {
  $c->mode_random(0);
  $c->selectedisnext(1);
  if ($c->curdiritem==$c->numdiritem-1) {
    $c->curdiritem(0);
  } else {
    $c->curdiritem($c->curdiritem+1);
  }
};

$buttons_browse{'left'} = sub {
  &loaddir('..');
  $c->mode_random(0);
};

$buttons_browse{'right'} = sub {
  $d_u && print "ircode right: ";
  $d_f && print "curdiritem == $c->curdiritem\n";
  if (&isdir($c->diritems($c->curdiritem))) {
    $d_f && print "isdir\n";
    &loaddir($c->diritems($c->curdiritem));
    $c->selectedisnext(1);
  } elsif (&ismp3($c->diritems($c->curdiritem))) {
    $d_f && print "ismp3\n";
    $c->selectedisnext(1);
    &opennext;
    &mp3_start;
    $c->selectedisnext(0);
    $c->mode_random(0);
  } else {
    $d_f && print "Error attempting to descend directory or open MP3\n";
  }
};

$buttons_browse{'fwd'} = sub {
  if ($irtimedif>2*$irmintime) {  # be extra paranoid about IR
    $c->selectedisnext(0);
    &opennext;
    &mp3_start;
  }
};

$buttons_browse{'stop'} = sub {
  &mp3_stop;
};

$buttons_browse{'pause'} = sub {
  &mp3_pause;
};

$buttons_browse{'chup'} = sub {
  &vfd_brightness_adj(+1);
};

$buttons_browse{'chdown'} = sub {
  &vfd_brightness_adj(-1); 
};

$buttons_browse{'ok'} = sub {
  $c->rand_basedir($c->pwd);
  $c->mode_random(1);
  &opennext;
  &mp3_start;
};

$buttons_browse{'disp'} = sub {
  &vfd_refresh;
};
