#
# SliMP3 Server
# Copyright (C) 2001 Sean Adams, Slim Devices Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.





sub cswrite {
  local ($key, $data)=@_;
  local ($i2c);
  die "Unknown CS4341 setting: $key\n" unless ($cs{$key});
  $i2c="s $cs{'devwrite'} $cs{$key} $data p";
  $i2c=~s/ //g;
  $i2c=~s/([\dA-Fa-f][\dA-Fa-f])/'w'.pack ("C", hex ($1))/eg;  # pack hex values and add write commands
  $i2c;
  }

sub csread {
  $i2c="s $cs{'devread'} r n p";
  $i2c=~s/ //g;
  $i2c=~s/([\dA-Fa-f][\dA-Fa-f])/'w'.pack ("C", hex ($1))/eg;  # pack hex values and add write, ack commands
  $i2c;
  }

$cslist='
# 
# CS4341 Registers
#
#
# Device address is 001000 . AD0 . R/W
#
# Device addresses for AD0 connected to ground
#
20 devwrite
21 devread
#
# For AD0 connected to +5V:
#22 devwrite
#23 devread

00 MCLK
01 Mode
02 Mixing
03 VolA
04 VolB

#
# Command format is:  START DEVADDR REGADDR DATA
#
';

foreach $line (split /\n/, $cslist) {
  $line=~s/#.*//;
  ($address, $label)=split ' ', $line;
  $cs{$label}=$address;
  }

1;


