#
# SliMP3 Server
# Copyright (C) 2001 Sean Adams, Slim Devices Inc.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


# At startup, detect what OS we're running
# sets the global $os to 'unix' 'win' or 'mac', and sets $p to
# '/', '/', or ':' for unix, win, or mac, respectively.

use Config;

if (!$os || ($os eq 'auto')) {
  $d_f && print "Auto-detecting OS: ".$Config{'osname'}."\n";
  if ($Config{'osname'}=~/^macos/i) {
    $os='mac';
    $p=':';
  } elsif ($Config{'osname'}=~/^m?s?win/i) {
    $os='win';
    $p='/';
  } else {
    $os='unix';
    $p='/';
  }
  $d_f && print "I think it's \"$os\".\n";
} else {
  $d_f && print "OS detection skipped, using \"$os\".\n";
}
$d_f && print "Using this path separator: \"$p\"\n";


# figure out where the prefs file should be on this platform:

if ($os eq 'mac') {
  require "FindFolder.pl";
  require "StandardFile.pl";
  $prefs_file = MacPerl::FindFolder('P')."SliMP3 Preferences";
}

if ($os eq 'unix') {
  $prefs_file = $ENV{'HOME'}.'/.slimp3.conf';
}

if ($os eq 'win')  {
  $prefs_file = 'C:\WINDOWS\SLIMP3.INI';
}


1;
